<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Circle Drawer 2</title>
    <link rel="stylesheet" href="style.css" />
    <script type="text/javascript" src="../packages/hotdrink.js"></script>
    <script type="text/javascript" src="../packages/lz-string.js"></script>
    <script type="module" src="circle-drawer.js"></script>
  </head>
  <body>
    <h1>Circle Drawer 2</h1>
    <table>
      <tr>
        <td class="overlay">
          <button id="undo">Undo</button>
          <button id="redo">Redo</button>
          <button id="start" onclick="startRecording()">Start Recording</button>
          <button id="stop" onclick="stopRecording()">Stop Recording</button>
          <button id="replay" onclick="replay()">Replay</button>
          <button
            id="show"
            onclick="document.getElementById('dsl-overlay').hidden = false"
          >
            Show DSL
          </button>
        </td>
      </tr>
      <tr>
        <td>
          <canvas id="canvas" width="1500" height="800"></canvas>
        </td>
      </tr>
    </table>
    <div id="adjust" class="modal">
      <div class="modal-content">
        <span class="close">&times;</span>
        <p>Adjust diameter</p>
        <input type="range" min="1" max="150" id="slider" />
      </div>
    </div>

    <script>
      const cs = hd.defaultConstraintSystem;

      function startRecording() {
        let startElement = document.getElementById("start");
        let stopElement = document.getElementById("stop");
        startElement.disabled = true;
        stopElement.disabled = false;

        cs.recorder.startRecording();
      }

      function stopRecording() {
        let startElement = document.getElementById("start");
        let stopElement = document.getElementById("stop");
        startElement.disabled = false;
        stopElement.disabled = true;
        cs.recorder.stopRecording();
      }

      async function replay() {
        cs.recorder.replay();
        await cs.update();
      }

      function updateDSLText() {
        let dslElement = document.getElementById("dsl");
        dslElement.value = cs.recorder.toDSL();
        // .split(";")
        // .join(";\n");
      }

      function parseDSLText() {
        cs.resetRecorder();
        let dslElement = document.getElementById("dsl");
        cs.parseRecorderDSL(dslElement.value, false, true);
      }
    </script>
    <div id="dsl-overlay" hidden>
      <div id="mask"></div>
      <div id="overlay_window">
        <table class="overlay">
          <tbody class="overlay">
            <tr id="heading">
              <td class="overlay" colspan="3"><h1>DSL</h1></td>
            </tr>
            <tr class="overlay">
              <td class="overlay" colspan="3">
                <textarea class="overlay" id="dsl"></textarea>
              </td>
            </tr>
          </tbody>
          <tfoot class="overlay">
            <tr class="overlay">
              <td class="overlay">
                <button id="update-dsl" onclick="updateDSLText()">
                  Update DSL
                </button>
              </td>
              <td class="overlay">
                <button id="parse-dsl" onclick="parseDSLText()">
                  Parse DSL
                </button>
              </td>
              <td class="overlay">
                <button
                  class="overlay"
                  id="hide"
                  onclick="document.getElementById('dsl-overlay').hidden = true"
                >
                  Hide
                </button>
              </td>
            </tr>
          </tfoot>
        </table>
      </div>
    </div>
  </body>
</html>
